## lacme 0.1

=== Makefile ===
MANPAGES = lacme-accountd.1 lacme.1

all: ${MANPAGES}

# upper case the headers and remove the links
%.1: %.md
	@pandoc -S -f markdown -t json "$<" | \
	jq ".[1][] |= if .t == \"Header\" then .c[2][] |= (if .t == \"Str\" then .c |= ascii_upcase else . end) else . end" | \
	jq "																						\
		def fixit:																				\
			if type == \"object\" then															\
				if .t == \"Link\" then															\
					if .c[2][0][0:7] == \"mailto:\" then . else	.c[1][]	end						\
				else																			\
					map_values(fixit)															\
				end																				\
			else if type == \"array\" then														\
					map(fixit)																	\
				else																			\
					.																			\
				end																				\
			end;																				\
		map(fixit)" | \
	pandoc -sS -f json -t man -o "$@"

install: ${MANPAGES}
	install -d $(DESTDIR)/etc/lacme
	install -m0644 -t $(DESTDIR)/etc/lacme config/*.conf
	install -d $(DESTDIR)/usr/share/lacme
	install -m0644 -t $(DESTDIR)/usr/share/lacme certs/lets-encrypt-x[1-4]-cross-signed.pem
	install -d $(DESTDIR)/usr/lib/lacme
	install -m0755 -t $(DESTDIR)/usr/lib/lacme client webserver
	install -d $(DESTDIR)/usr/share/man/man1
	install -m0644 -t $(DESTDIR)/usr/share/man/man1 lacme-accountd.1 lacme.1
	install -d $(DESTDIR)/usr/bin
	install -m0644 -t $(DESTDIR)/usr/bin lacme-accountd
	install -d $(DESTDIR)/usr/sbin
	install -m0644 -t $(DESTDIR)/usr/bin lacme

clean:
	rm -vf ${MANPAGES}

.PHONY: all install clean

=== debian/changelog ===
lacme (0.1-1) unstable; urgency=low

  * Initial release.  (Closes: #827357, #827358.)

 -- Guilhem Moulin <guilhem@guilhem.org>  Tue, 08 Dec 2015 18:58:20 +0100

=== debian/control ===
Source: lacme
Section: utils
Priority: optional
Maintainer: Guilhem Moulin <guilhem@guilhem.org>
Build-Depends: debhelper (>= 9), jq, pandoc
Standards-Version: 3.9.6
Homepage: https://git.guilhem.org/lacme/about/
Vcs-Git: https://git.guilhem.org/lacme
Vcs-Browser: https://git.guilhem.org/lacme

Package: lacme
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
 openssl,
 libconfig-tiny-perl,
 libjson-perl,
 libwww-perl,
 libnet-ssleay-perl
Recommends: liblwp-protocol-https-perl
Suggests: lacme-accountd (= ${binary:Version})
Description: ACME client written with process isolation and minimal privileges in mind
 lacme is divided into four components, each with its own executable:
 .
  * A process to manage the account key and issue SHA-256 signatures needed for
    each ACME command.  (This process binds to a UNIX-domain socket to reply to
    signature requests from the ACME client.)  One can use the UNIX-domain
    socket forwarding facility of OpenSSH 6.7 and later to run this process on
    a different host.
 .
  * A "master" process, which runs as root and is the only component
    with access to the private key material of the server keys.  It is used to
    fork the ACME client (and optionally the ACME webserver) after dropping
    root privileges.  For certificate issuances, it also generates Certificate
    Signing Requests, then verifies the validity of the issued certificate, and
    optionally reloads or restarts services.
 .
  * An actual ACME client, which builds ACME commands and dialogues with
    the remote ACME server.  Since ACME commands need to be signed with the
    account key, the "master" process passes the UNIX-domain socket of the
    account key manager to the ACME client: data signatures are requested by
    writing the data to be signed to the socket.
 .
  * For certificate issuances, an optional webserver, which is spawned
    by the "master" process when no service is listening on the HTTP port.
    (The only challenge type currently supported is "http-01", which requires a
    webserver to answer challenges.)  That webserver only processes GET and
    HEAD requests under the "/.well-known/acme-challenge/" URI.  By default
    some iptables(8) rules are automatically installed to open the HTTP port,
    and removed afterwards.

Package: lacme-accountd
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
 libconfig-tiny-perl,
 libjson-perl
Recommends: libcrypt-openssl-rsa-perl
Description: lacme account key manager
 lacme is an ACME client written with process isolation and minimal privileges
 in mind.  It is divided into four components, each with its own executable:
 .
  * A process to manage the account key and issue SHA-256 signatures needed for
    each ACME command.  (This process binds to a UNIX-domain socket to reply to
    signature requests from the ACME client.)  One can use the UNIX-domain
    socket forwarding facility of OpenSSH 6.7 and later to run this process on
    a different host.
 .
  * A "master" process, which runs as root and is the only component
    with access to the private key material of the server keys.  It is used to
    fork the ACME client (and optionally the ACME webserver) after dropping
    root privileges.  For certificate issuances, it also generates Certificate
    Signing Requests, then verifies the validity of the issued certificate, and
    optionally reloads or restarts services.
 .
  * An actual ACME client, which builds ACME commands and dialogues with
    the remote ACME server.  Since ACME commands need to be signed with the
    account key, the "master" process passes the UNIX-domain socket of the
    account key manager to the ACME client: data signatures are requested by
    writing the data to be signed to the socket.
 .
  * For certificate issuances, an optional webserver, which is spawned
    by the "master" process when no service is listening on the HTTP port.
    (The only challenge type currently supported is "http-01", which requires a
    webserver to answer challenges.)  That webserver only processes GET and
    HEAD requests under the "/.well-known/acme-challenge/" URI.  By default
    some iptables(8) rules are automatically installed to open the HTTP port,
    and removed afterwards.
 .
 lacme-accountd is the first (account key manager) component.  It is the only
 component with access to the account key.

## lacme 0.2

=== debian/changelog ===
lacme (0.2-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    + Promote lacme-accountd from lacme's Suggests to Recommends.
    + Bump Standards-Version to 3.9.8.  No changes.

 -- Guilhem Moulin <guilhem@guilhem.org>  Mon, 05 Dec 2016 16:35:59 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Guilhem Moulin <guilhem@guilhem.org>
 Build-Depends: debhelper (>= 9), jq, pandoc
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://git.guilhem.org/lacme/about/
 Vcs-Git: https://git.guilhem.org/lacme
 Vcs-Browser: https://git.guilhem.org/lacme
@@ -16,8 +16,7 @@
  libjson-perl,
  libwww-perl,
  libnet-ssleay-perl
-Recommends: liblwp-protocol-https-perl
-Suggests: lacme-accountd (= ${binary:Version})
+Recommends: liblwp-protocol-https-perl, lacme-accountd (= ${binary:Version})
 Description: ACME client written with process isolation and minimal privileges in mind
  lacme is divided into four components, each with its own executable:
  .

## lacme 0.3

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,7 @@
 
 install: ${MANPAGES}
 	install -d $(DESTDIR)/etc/lacme
+	install -d $(DESTDIR)/etc/lacme/lacme-certs.conf.d
 	install -m0644 -t $(DESTDIR)/etc/lacme config/*.conf
 	install -d $(DESTDIR)/usr/share/lacme
 	install -m0644 -t $(DESTDIR)/usr/share/lacme certs/lets-encrypt-x[1-4]-cross-signed.pem

=== debian/changelog ===
lacme (0.3-1) unstable; urgency=low

  * New upstream release.
  * Provide apache2 and nginx configuration snippet in /etc/lacme.
  * debian/control: Bump Standards-Version to 4.0.0.  No changes.

 -- Guilhem Moulin <guilhem@debian.org>  Sun, 09 Jul 2017 00:41:23 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: lacme
 Section: utils
 Priority: optional
-Maintainer: Guilhem Moulin <guilhem@guilhem.org>
+Maintainer: Guilhem Moulin <guilhem@debian.org>
 Build-Depends: debhelper (>= 9), jq, pandoc
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://git.guilhem.org/lacme/about/
 Vcs-Git: https://git.guilhem.org/lacme
 Vcs-Browser: https://git.guilhem.org/lacme

## lacme 0.4

=== Makefile ===
MANPAGES = lacme-accountd.1 lacme.1

all: ${MANPAGES}

# upper case the headers and remove the links
%.1: %.md
	@pandoc -S -f markdown -t json "$<" | \
	jq "                                                                        \
	    def fixheaders:                                                         \
	        if .t == \"Header\" then                                            \
	            .c[2][] |= (if .t == \"Str\" then .c |= ascii_upcase else . end)\
	        else                                                                \
	            .                                                               \
	        end;                                                                \
	    def fixlinks:                                                           \
	        if type == \"object\" then                                          \
	            if .t == \"Link\" then                                          \
	                if .c[2][0][0:7] == \"mailto:\" then . else .c[1][] end     \
	            else                                                            \
	                map_values(fixlinks)                                        \
	            end                                                             \
	        else if type == \"array\" then                                      \
	                map(fixlinks)                                               \
	            else                                                            \
	                .                                                           \
	            end                                                             \
	        end;                                                                \
	    { \"pandoc-api-version\"                                                \
	    , meta                                                                  \
	    , blocks: .blocks | map(fixheaders) | map(fixlinks)                     \
	    }" | \
	pandoc -sS -f json -t man -o "$@"

install: ${MANPAGES}
	install -d $(DESTDIR)/etc/lacme
	install -d $(DESTDIR)/etc/lacme/lacme-certs.conf.d
	install -m0644 -t $(DESTDIR)/etc/lacme config/*.conf
	install -m0644 -t $(DESTDIR)/etc/lacme snippets/*.conf
	install -d $(DESTDIR)/usr/share/lacme
	install -m0644 -t $(DESTDIR)/usr/share/lacme certs/lets-encrypt-x[1-4]-cross-signed.pem
	install -d $(DESTDIR)/usr/lib/lacme
	install -m0755 -t $(DESTDIR)/usr/lib/lacme client webserver
	install -d $(DESTDIR)/usr/share/man/man1
	install -m0644 -t $(DESTDIR)/usr/share/man/man1 lacme-accountd.1 lacme.1
	install -d $(DESTDIR)/usr/bin
	install -m0644 -t $(DESTDIR)/usr/bin lacme-accountd
	install -d $(DESTDIR)/usr/sbin
	install -m0644 -t $(DESTDIR)/usr/bin lacme

clean:
	rm -vf ${MANPAGES}

.PHONY: all install clean

=== debian/changelog ===
lacme (0.4-1) unstable; urgency=medium

  * Fix manpage generation with pandoc >=1.18.  (Closes: #869885.)

 -- Guilhem Moulin <guilhem@debian.org>  Fri, 28 Jul 2017 00:24:06 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Guilhem Moulin <guilhem@debian.org>
-Build-Depends: debhelper (>= 9), jq, pandoc
+Build-Depends: debhelper (>= 9), jq, pandoc (>= 1.18~)
 Standards-Version: 4.0.0
 Homepage: https://git.guilhem.org/lacme/about/
 Vcs-Git: https://git.guilhem.org/lacme

## lacme 0.5

=== debian/changelog ===
lacme (0.5-1) unstable; urgency=medium

  * New upstream release, adding support for v2 ACME endpoints.
  * Fix manpage generation with pandoc >=2.1.  (Closes: #896982.)
  * debian/control:
    + Bump Standards-Version to 4.1.4.  No changes.
    + Build-depends: bump minimum pandoc version to 2.1.
    + Depends (lacme): add libtypes-serialiser-perl

 -- Guilhem Moulin <guilhem@debian.org>  Wed, 09 May 2018 14:17:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,21 +2,23 @@
 Section: utils
 Priority: optional
 Maintainer: Guilhem Moulin <guilhem@debian.org>
-Build-Depends: debhelper (>= 9), jq, pandoc (>= 1.18~)
-Standards-Version: 4.0.0
+Build-Depends: debhelper (>= 9), jq, pandoc (>= 2.1~)
+Standards-Version: 4.1.4
 Homepage: https://git.guilhem.org/lacme/about/
 Vcs-Git: https://git.guilhem.org/lacme
 Vcs-Browser: https://git.guilhem.org/lacme
 
 Package: lacme
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends},
- openssl,
- libconfig-tiny-perl,
- libjson-perl,
- libwww-perl,
- libnet-ssleay-perl
-Recommends: liblwp-protocol-https-perl, lacme-accountd (= ${binary:Version})
+Depends: libconfig-tiny-perl,
+         libjson-perl,
+         libnet-ssleay-perl,
+         libtypes-serialiser-perl,
+         libwww-perl,
+         openssl,
+         ${misc:Depends},
+         ${perl:Depends}
+Recommends: lacme-accountd (= ${binary:Version}), liblwp-protocol-https-perl
 Description: ACME client written with process isolation and minimal privileges in mind
  lacme is divided into four components, each with its own executable:
  .
@@ -49,9 +51,7 @@
 
 Package: lacme-accountd
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends},
- libconfig-tiny-perl,
- libjson-perl
+Depends: libconfig-tiny-perl, libjson-perl, ${misc:Depends}, ${perl:Depends}
 Recommends: libcrypt-openssl-rsa-perl
 Description: lacme account key manager
  lacme is an ACME client written with process isolation and minimal privileges

## lacme 0.6

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 # upper case the headers and remove the links
 %.1: %.md
-	@pandoc -S -f markdown -t json "$<" | \
+	@pandoc -f markdown -t json "$<" | \
 	jq "                                                                        \
 	    def fixheaders:                                                         \
 	        if .t == \"Header\" then                                            \
@@ -29,7 +29,7 @@
 	    , meta                                                                  \
 	    , blocks: .blocks | map(fixheaders) | map(fixlinks)                     \
 	    }" | \
-	pandoc -sS -f json -t man -o "$@"
+	pandoc -s -f json -t man+smart -o "$@"
 
 install: ${MANPAGES}
 	install -d $(DESTDIR)/etc/lacme

=== debian/changelog ===
lacme (0.6-3) unstable; urgency=medium

  * New symlink /etc/apache2/conf-available/lacme.conf pointing to
    /etc/lacme/apache2.conf for use with the a2enconf/a2disconf interface.
    (Closes: #955859.)
  * debian/*.{install,manpages}: Copy files from $DESTDIR (debian/tmp) not
    from the source tree.
  * debian/control:
    + Add "Rules-Requires-Root: no".
    + Add "debhelper-compat (= 12)" to Build-Depends.
    + Bump Standards-Version to 4.5.0 (no changes necessary).
  * Rename debian/source.lintian-overrides to debian/source/lintian-overrides.

 -- Guilhem Moulin <guilhem@debian.org>  Sun, 05 Apr 2020 18:26:36 +0200

lacme (0.6-2) unstable; urgency=medium

  * d/control: new dependency for lacme: libtimedate-perl.  (It's currently a
    reverse dependency of LWP, but we use it explicitly.)

 -- Guilhem Moulin <guilhem@debian.org>  Wed, 18 Sep 2019 15:41:03 +0200

lacme (0.6-1) unstable; urgency=medium

  * New upstream release.
  * d/control: Bump Standards-Version to 4.4.0 (no changes necessary).
  * d/compat, d/control: Bump debhelper compatibility level to 12.

 -- Guilhem Moulin <guilhem@debian.org>  Wed, 21 Aug 2019 23:50:15 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: utils
 Priority: optional
 Maintainer: Guilhem Moulin <guilhem@debian.org>
-Build-Depends: debhelper (>= 9), jq, pandoc (>= 2.1~)
-Standards-Version: 4.1.4
+Build-Depends: debhelper-compat (= 12), jq, pandoc (>= 2.1~)
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://git.guilhem.org/lacme/about/
 Vcs-Git: https://git.guilhem.org/lacme
 Vcs-Browser: https://git.guilhem.org/lacme
@@ -13,6 +14,7 @@
 Depends: libconfig-tiny-perl,
          libjson-perl,
          libnet-ssleay-perl,
+         libtimedate-perl,
          libtypes-serialiser-perl,
          libwww-perl,
          openssl,
@@ -80,9 +82,8 @@
     by the "master" process when no service is listening on the HTTP port.
     (The only challenge type currently supported is "http-01", which requires a
     webserver to answer challenges.)  That webserver only processes GET and
-    HEAD requests under the "/.well-known/acme-challenge/" URI.  By default
-    some iptables(8) rules are automatically installed to open the HTTP port,
-    and removed afterwards.
+    HEAD requests under the "/.well-known/acme-challenge/" URI.  iptables(8)
+    rules can optionally be installed to temporarily open the HTTP port.
  .
  lacme-accountd is the first (account key manager) component.  It is the only
  component with access to the account key.

## lacme 0.6.1

=== Makefile ===
DESTDIR ?= /usr/local
BUILDDIR ?= ./build
MANUAL_FILES = $(addprefix $(BUILDDIR)/,$(patsubst ./%.md,%,$(wildcard ./*.[1-9].md)))

all: manual $(addprefix $(BUILDDIR)/,lacme lacme-accountd client webserver $(wildcard config/* snippets/*))
doc: manual

manual: $(MANUAL_FILES)

# upper case the headers and remove the links
$(MANUAL_FILES): $(BUILDDIR)/%: $(BUILDDIR)/%.md
	pandoc -f markdown -t json -- "$<" | ./pandoc2man.jq | pandoc -s -f json -t man -o "$@"

prefix ?= $(DESTDIR)
exec_prefix ?= $(prefix)
bindir ?= $(exec_prefix)/bin
sbindir ?= $(exec_prefix)/sbin
libexecdir ?= $(exec_prefix)/libexec
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
sysconfdir ?= $(prefix)/etc
localstatedir =? $(prefix)/var
runstatedir ?= $(localstatedir)/run
mandir ?= $(datarootdir)/man
man1dir ?= $(mandir)/man1
man8dir ?= $(mandir)/man8

$(BUILDDIR)/%: %
	mkdir -pv -- $(dir $@)
	cp --no-dereference --preserve=mode,links,xattr -vfT -- "$<" "$@"
	sed -i "s#@@bindir@@#$(bindir)#g; \
	        s#@@sbindir@@#$(sbindir)#g; \
	        s#@@libexecdir@@#$(libexecdir)#g; \
	        s#@@datadir@@#$(datadir)#g; \
	        s#@@runstatedir@@#$(runstatedir)#g; \
	        s#@@sysconfdir@@#$(sysconfdir)#g;" -- "$@"

install: all
	install -m0644 -vDt $(sysconfdir)/lacme $(BUILDDIR)/config/*.conf $(BUILDDIR)/snippets/*.conf
	install -vd $(sysconfdir)/lacme/lacme-certs.conf.d
	install -m0644 -vDt $(datadir)/lacme certs/lets-encrypt-x[1-4]-cross-signed.pem
	install -m0755 -vDt $(libexecdir)/lacme $(BUILDDIR)/client $(BUILDDIR)/webserver
	install -m0644 -vDt $(man1dir) $(BUILDDIR)/lacme-accountd.1
	install -m0644 -vDt $(man8dir) $(BUILDDIR)/lacme.8
	install -m0644 -vDt $(bindir) $(BUILDDIR)/lacme-accountd
	install -m0644 -vDt $(sbindir) $(BUILDDIR)/lacme

uninstall:
	rm -vf -- $(bindir)/lacme-accountd $(sbindir)/lacme
	rm -vf -- $(man1dir)/lacme-accountd.1 $(man8dir)/lacme.8
	rm -rvf -- $(sysconfdir)/lacme $(datadir)/lacme $(libexecdir)/lacme

clean:
	rm -rvf -- $(BUILDDIR)

.PHONY: all doc manual install uninstall clean

=== debian/changelog ===
lacme (0.6.1-1) unstable; urgency=medium

  * New upstream release.  Closes: #955767, #966958.
    + Default listening socket for the webserver component is now
      /run/lacme-www.socket.  (It was previously under the legacy directory
      /var/run.)
  * debian/*: Adapt to new build system.
  * debian/control: Bump debhelper compatibility level to 13.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 04 Aug 2020 01:43:05 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Guilhem Moulin <guilhem@debian.org>
-Build-Depends: debhelper-compat (= 12), jq, pandoc (>= 2.1~)
+Build-Depends: debhelper-compat (= 13), jq, pandoc (>= 2.1~)
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: https://git.guilhem.org/lacme/about/

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_build:
	dh_auto_build -- DESTDIR= exec_prefix=/usr datadir=/usr/share runstatedir=/run

%:
	dh $@

## lacme 0.7

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 BUILDDIR ?= ./build
 MANUAL_FILES = $(addprefix $(BUILDDIR)/,$(patsubst ./%.md,%,$(wildcard ./*.[1-9].md)))
 
-all: manual $(addprefix $(BUILDDIR)/,lacme lacme-accountd client webserver $(wildcard config/* snippets/*))
+all: manual $(addprefix $(BUILDDIR)/,lacme lacme-accountd client webserver $(wildcard certs/* config/* snippets/*) certs/ca-certificates.crt)
 doc: manual
 
 manual: $(MANUAL_FILES)
@@ -10,6 +10,16 @@
 # upper case the headers and remove the links
 $(MANUAL_FILES): $(BUILDDIR)/%: $(BUILDDIR)/%.md
 	pandoc -f markdown -t json -- "$<" | ./pandoc2man.jq | pandoc -s -f json -t man -o "$@"
+
+# used for validation, see https://letsencrypt.org/certificates/
+$(BUILDDIR)/certs/ca-certificates.crt: \
+        certs/letsencryptauthorityx[34].pem \
+        certs/lets-encrypt-x[34]-cross-signed.pem \
+        certs/lets-encrypt-r[34].pem \
+        certs/lets-encrypt-r[34]-cross-signed.pem \
+        certs/lets-encrypt-e[12].pem
+	mkdir -pv -- $(BUILDDIR)/certs
+	cat $^ >$@
 
 prefix ?= $(DESTDIR)
 exec_prefix ?= $(prefix)
@@ -38,7 +48,7 @@
 install: all
 	install -m0644 -vDt $(sysconfdir)/lacme $(BUILDDIR)/config/*.conf $(BUILDDIR)/snippets/*.conf
 	install -vd $(sysconfdir)/lacme/lacme-certs.conf.d
-	install -m0644 -vDt $(datadir)/lacme certs/lets-encrypt-x[1-4]-cross-signed.pem
+	install -m0644 -vDt $(datadir)/lacme $(BUILDDIR)/certs/*
 	install -m0755 -vDt $(libexecdir)/lacme $(BUILDDIR)/client $(BUILDDIR)/webserver
 	install -m0644 -vDt $(man1dir) $(BUILDDIR)/lacme-accountd.1
 	install -m0644 -vDt $(man8dir) $(BUILDDIR)/lacme.8

=== debian/changelog ===
lacme (0.7-1) unstable; urgency=high

  * New upstream release.  Closes: #975862.

 -- Guilhem Moulin <guilhem@debian.org>  Thu, 26 Nov 2020 00:05:55 +0100

## lacme 0.8.0

=== Makefile ===
DESTDIR ?= /usr/local
BUILDDIR ?= ./build
MANUAL_FILES = $(addprefix $(BUILDDIR)/,$(patsubst ./%.md,%,$(wildcard ./*.[1-9].md)))

all: manual $(addprefix $(BUILDDIR)/,lacme lacme-accountd client webserver \
	$(wildcard certs/* config/* snippets/*) \
	certs/ca-certificates.crt certs-staging/ca-certificates.crt)
doc: manual

manual: $(MANUAL_FILES)

# upper case the headers and remove the links
$(MANUAL_FILES): $(BUILDDIR)/%: $(BUILDDIR)/%.md
	pandoc -f markdown -t json -- "$<" | ./pandoc2man.jq | pandoc -s -f json -t man -o "$@"

# used for validation, see https://letsencrypt.org/certificates/
$(BUILDDIR)/certs/ca-certificates.crt: \
        certs/isrgrootx1.pem \
        certs/isrg-root-x2.pem \
        certs/lets-encrypt-r[34].pem \
        certs/lets-encrypt-e[12].pem
	mkdir -pv -- $(dir $@)
	cat -- $^ >$@

# Staging Environment for tests, see https://letsencrypt.org/docs/staging-environment/
$(BUILDDIR)/certs-staging/ca-certificates.crt: \
        certs-staging/letsencrypt-stg-root-x[12].pem \
        certs-staging/letsencrypt-stg-int-r[34].pem \
        certs-staging/letsencrypt-stg-int-e[12].pem
	mkdir -pv -- $(dir $@)
	cat -- $^ >$@

prefix ?= $(DESTDIR)
exec_prefix ?= $(prefix)
bindir ?= $(exec_prefix)/bin
sbindir ?= $(exec_prefix)/sbin
libexecdir ?= $(exec_prefix)/libexec
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
sysconfdir ?= $(prefix)/etc
localstatedir ?= $(prefix)/var
runstatedir ?= $(localstatedir)/run
mandir ?= $(datarootdir)/man
man1dir ?= $(mandir)/man1
man8dir ?= $(mandir)/man8

lacme_www_user ?= www-data
lacme_www_group ?= www-data
lacme_client_user ?= nobody
lacme_client_group ?= nogroup

acmeapi_server ?= https://acme-v02.api.letsencrypt.org/directory

$(BUILDDIR)/%: %
	mkdir -pv -- $(dir $@)
	cp --no-dereference --preserve=mode,links,xattr -vfT -- "$<" "$@"
	sed -i "s#@@bindir@@#$(bindir)#g; \
	        s#@@sbindir@@#$(sbindir)#g; \
	        s#@@libexecdir@@#$(libexecdir)#g; \
	        s#@@datadir@@#$(datadir)#g; \
	        s#@@localstatedir@@#$(localstatedir)#g; \
	        s#@@runstatedir@@#$(runstatedir)#g; \
	        s#@@sysconfdir@@#$(sysconfdir)#g; \
	        s#@@lacme_www_user@@#$(lacme_www_user)#g; \
	        s#@@lacme_www_group@@#$(lacme_www_group)#g; \
	        s#@@lacme_client_user@@#$(lacme_client_user)#g; \
	        s#@@lacme_client_group@@#$(lacme_client_group)#g; \
	        s#@@acmeapi_server@@#$(acmeapi_server)#g; \
	        " -- "$@"

release:
	@if ! git diff HEAD --quiet -- ./Changelog ./lacme ./lacme-accountd ./client; then \
		echo "Dirty state, refusing to release!" >&2; \
		exit 1; \
	fi
	VERS=$$(dpkg-parsechangelog -l Changelog -SVersion 2>/dev/null) && \
		if git rev-parse -q --verify "refs/tags/v$$VERS" >/dev/null; then echo "tag exists" 2>/dev/null; exit 1; fi && \
		sed -ri "0,/^( -- .*)  .*/ s//\\1  $(shell date -R)/" ./Changelog && \
		sed -ri "0,/^(our\\s+\\\$$VERSION\\s*=\\s*)'[0-9.]+'\\s*;/ s//\\1'$$VERS';/" \
			-- ./lacme ./lacme-accountd ./client && \
		git commit -m "Prepare new release v$$VERS." \
			-- ./Changelog ./lacme ./lacme-accountd ./client && \
		git tag -sm "Release version $$VERS" "v$$VERS"

install: all
	install -m0644 -vDt $(sysconfdir)/lacme -- $(BUILDDIR)/config/*.conf $(BUILDDIR)/snippets/*.conf
	install -m0755 -vd -- $(sysconfdir)/lacme/lacme-certs.conf.d
	install -m0644 -vDt $(datadir)/lacme -- $(BUILDDIR)/certs/*
	install -m0755 -vDt $(libexecdir)/lacme -- $(BUILDDIR)/client $(BUILDDIR)/webserver
	install -m0644 -vDt $(man1dir) -- $(BUILDDIR)/lacme-accountd.1
	install -m0644 -vDt $(man8dir) -- $(BUILDDIR)/lacme.8
	install -m0755 -vDt $(sbindir) -- $(BUILDDIR)/lacme
	install -m0755 -vDt $(bindir) -- $(BUILDDIR)/lacme-accountd
	install -m0755 -vdD -- $(sysconfdir)/apache2/conf-available
	ln -sv -- ../../lacme/apache2.conf $(sysconfdir)/apache2/conf-available/lacme.conf

uninstall:
	rm -vf -- $(bindir)/lacme-accountd $(sbindir)/lacme
	rm -vf -- $(man1dir)/lacme-accountd.1 $(man8dir)/lacme.8
	rm -rvf -- $(sysconfdir)/lacme $(datadir)/lacme $(libexecdir)/lacme
	rm -vf -- $(sysconfdir)/apache2/conf-available/lacme.conf

clean:
	rm -rvf -- $(BUILDDIR)

.PHONY: all doc manual release install uninstall clean

=== debian/changelog ===
lacme (0.8.0-2) unstable; urgency=medium

  * d/lacme.postrm: Don't delete system users on purge.  There might be files
    on disk owned by _lacme-client when 'challenge-directory' is set in the
    configuration (closes: #988032).

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 04 May 2021 01:37:13 +0200

lacme (0.8.0-1) unstable; urgency=low

  * New upstream release (closes: #970458, #970800, #972456).
  * The internal webserver now runs as a dedicated system user _lacme-www
    (and group nogroup) instead of www-data:www-data.  This is configurable
    in the [webserver] section of the lacme(8) configuration file.
  * The internal ACME client now runs as a dedicated system user _lacme-client
    (and group nogroup) instead of nobody:nogroup.  This is configurable in
    the [client] section of the lacme(8) configuration file.
  * The _lacme-www and _lacme-client system users are created automatically by
    lacme.postinst (hence a new Depends: adduser), and deleted on purge.  (So
    make sure not to chown any file to these internal users.)
  * d/control: New lacme-accountd Suggests: openssl, gpg (for account key
    generation and decryption).
  * Add d/upstream/signing-key.asc, the OpenPGP used to signed upstream tags.
  * d/control: Bump Standards-Version to 4.5.1 (no changes necessary).
  * Add d/watch pointing to the upstream repository.
  * d/gbp.conf: Update upstream tag template.
  * d/gbp.conf: Update debian and upstream branches in compliance with DEP-14.
  * d/control: Point Vcs-* to salsa.
  * Add debian/salsa-ci.yml file.
  * d/.gitattributes: New file to merge d/changelog with dpkg-mergechangelogs.
  * Add d/upstream/metadata with Repository and Repository-Browse.
  * d/control: Remove libtypes-serialiser-perl from lacme's Depends.
  * d/control: lacme now require openssl 1.1.0 or later.
  * d/copyright: Bump copyright years.
  * d/copyright: Point Source: to the upstream repository.
  * d/control: lacme recommends lacme-accountd 0.8.0-1 or later.
  * d/lacme.links: Remove /etc/apache2/conf-available/lacme.conf, now part of
    the upstream build system.
  * d/lacme.install: include new configuration files and snippets.

 -- Guilhem Moulin <guilhem@debian.org>  Mon, 22 Feb 2021 03:31:23 +0100

=== debian/control ===
--- 
+++ 
@@ -4,23 +4,23 @@
 Maintainer: Guilhem Moulin <guilhem@debian.org>
 Build-Depends: debhelper-compat (= 13), jq, pandoc (>= 2.1~)
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://git.guilhem.org/lacme/about/
-Vcs-Git: https://git.guilhem.org/lacme
-Vcs-Browser: https://git.guilhem.org/lacme
+Vcs-Git: https://salsa.debian.org/debian/lacme.git -b debian/latest
+Vcs-Browser: https://salsa.debian.org/debian/lacme
 
 Package: lacme
 Architecture: all
-Depends: libconfig-tiny-perl,
+Depends: adduser,
+         libconfig-tiny-perl,
          libjson-perl,
          libnet-ssleay-perl,
          libtimedate-perl,
-         libtypes-serialiser-perl,
          libwww-perl,
-         openssl,
+         openssl (>= 1.1.0~),
          ${misc:Depends},
          ${perl:Depends}
-Recommends: lacme-accountd (= ${binary:Version}), liblwp-protocol-https-perl
+Recommends: lacme-accountd (>= 0.8.0), liblwp-protocol-https-perl
 Description: ACME client written with process isolation and minimal privileges in mind
  lacme is divided into four components, each with its own executable:
  .
@@ -55,6 +55,7 @@
 Architecture: all
 Depends: libconfig-tiny-perl, libjson-perl, ${misc:Depends}, ${perl:Depends}
 Recommends: libcrypt-openssl-rsa-perl
+Suggests: gpg, openssl
 Description: lacme account key manager
  lacme is an ACME client written with process isolation and minimal privileges
  in mind.  It is divided into four components, each with its own executable:

## lacme 0.8.1

=== debian/changelog ===
lacme (0.8.1-1) unstable; urgency=medium

  [ Guilhem Moulin ]
  * New upstream bugfix release.
  * Salsa CI: Remove default configuration file.
  * d/control: Improve long package descriptions.
  * Set field Upstream-Name in debian/copyright.
  * Update standards version to 4.6.2, no changes needed.

  [ Debian Janitor ]
  * d/control: Add 'Multi-Arch: foreign' mark.

 -- Guilhem Moulin <guilhem@debian.org>  Wed, 25 Jan 2023 03:33:11 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Guilhem Moulin <guilhem@debian.org>
 Build-Depends: debhelper-compat (= 13), jq, pandoc (>= 2.1~)
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Homepage: https://git.guilhem.org/lacme/about/
 Vcs-Git: https://salsa.debian.org/debian/lacme.git -b debian/latest
 Vcs-Browser: https://salsa.debian.org/debian/lacme
@@ -22,7 +22,9 @@
          ${perl:Depends}
 Recommends: lacme-accountd (>= 0.8.0), liblwp-protocol-https-perl
 Description: ACME client written with process isolation and minimal privileges in mind
- lacme is divided into four components, each with its own executable:
+ lacme is an ACME client which can be used to request X.509 certificates from
+ ACME service providers such as Let's Encrypt or ZeroSSL.  The architecture is
+ divided into four components, each with its own executable:
  .
   * A process to manage the account key and issue SHA-256 signatures needed for
     each ACME command.  (This process binds to a UNIX-domain socket to reply to
@@ -56,9 +58,12 @@
 Depends: libconfig-tiny-perl, libjson-perl, ${misc:Depends}, ${perl:Depends}
 Recommends: libcrypt-openssl-rsa-perl
 Suggests: gpg, openssl
+Multi-Arch: foreign
 Description: lacme account key manager
- lacme is an ACME client written with process isolation and minimal privileges
- in mind.  It is divided into four components, each with its own executable:
+ lacme is an ACME client which can be used to request X.509 certificates from
+ ACME service providers such as Let's Encrypt or ZeroSSL.  The architecture is
+ designed with process isolation and minimal privileges in mind, and is divided
+ into four components:
  .
   * A process to manage the account key and issue SHA-256 signatures needed for
     each ACME command.  (This process binds to a UNIX-domain socket to reply to

## lacme 0.8.2

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
         certs/isrg-root-x2.pem \
         certs/lets-encrypt-r[34].pem \
         certs/lets-encrypt-e[12].pem
-	mkdir -pv -- $(dir $@)
+	mkdir -pv -- $(@D)
 	cat -- $^ >$@
 
 # Staging Environment for tests, see https://letsencrypt.org/docs/staging-environment/
@@ -27,7 +27,7 @@
         certs-staging/letsencrypt-stg-root-x[12].pem \
         certs-staging/letsencrypt-stg-int-r[34].pem \
         certs-staging/letsencrypt-stg-int-e[12].pem
-	mkdir -pv -- $(dir $@)
+	mkdir -pv -- $(@D)
 	cat -- $^ >$@
 
 prefix ?= $(DESTDIR)
@@ -52,7 +52,7 @@
 acmeapi_server ?= https://acme-v02.api.letsencrypt.org/directory
 
 $(BUILDDIR)/%: %
-	mkdir -pv -- $(dir $@)
+	mkdir -pv -- $(@D)
 	cp --no-dereference --preserve=mode,links,xattr -vfT -- "$<" "$@"
 	sed -i "s#@@bindir@@#$(bindir)#g; \
 	        s#@@sbindir@@#$(sbindir)#g; \

=== debian/changelog ===
lacme (0.8.2-1) unstable; urgency=medium

  * New upstream bugfix release.
    + client: Handle "ready" → "processing" → "valid" status change during
      newOrder, instead of just "ready" → "valid".  The latter may be what we
      observe when the server is fast enough, but according to RFC 8555 sec.
      7.1.6 the state actually transitions via "processing" state and we need
      to account for that.  Closes: #1034834.
    + Test suite: Point stretch's archive URL to archive.d.o.

 -- Guilhem Moulin <guilhem@debian.org>  Tue, 25 Apr 2023 20:08:21 +0200

## lacme 0.8.3

=== Makefile ===
--- 
+++ 
@@ -16,17 +16,13 @@
 # used for validation, see https://letsencrypt.org/certificates/
 $(BUILDDIR)/certs/ca-certificates.crt: \
         certs/isrgrootx1.pem \
-        certs/isrg-root-x2.pem \
-        certs/lets-encrypt-r[34].pem \
-        certs/lets-encrypt-e[12].pem
+        certs/isrg-root-x2.pem
 	mkdir -pv -- $(@D)
 	cat -- $^ >$@
 
 # Staging Environment for tests, see https://letsencrypt.org/docs/staging-environment/
 $(BUILDDIR)/certs-staging/ca-certificates.crt: \
-        certs-staging/letsencrypt-stg-root-x[12].pem \
-        certs-staging/letsencrypt-stg-int-r[34].pem \
-        certs-staging/letsencrypt-stg-int-e[12].pem
+        certs-staging/letsencrypt-stg-root-x[12].pem
 	mkdir -pv -- $(@D)
 	cat -- $^ >$@

=== debian/changelog ===
lacme (0.8.3-1) unstable; urgency=high

  * New upstream bugfix release.
    + Fix post-issuance validation logic.  We avoid pining the intermediate
      certificates in the bundle and instead validate the leaf certificate
      with intermediates supplied during issuance as untrusted (used for chain
      building only).  Only the root certificates are used as trust anchor.
      Not pining intermediate certificates is in line with Let's Encrypt's
      latest recommendations.
      Closes: #1072847
    + Pass `-in /dev/stdin` option to openssl(1) to avoid warning with OpenSSL
      3.2 or later.
    + Fix test suite to account for Let's Encrypt's (staging) ACME server
      changes.
  * d/control: Update Standards-Version to 4.7.0 (no changes necessary).

 -- Guilhem Moulin <guilhem@debian.org>  Thu, 13 Jun 2024 17:56:33 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Guilhem Moulin <guilhem@debian.org>
 Build-Depends: debhelper-compat (= 13), jq, pandoc (>= 2.1~)
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://git.guilhem.org/lacme/about/
 Vcs-Git: https://salsa.debian.org/debian/lacme.git -b debian/latest
 Vcs-Browser: https://salsa.debian.org/debian/lacme

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_build:
	dh_auto_build -- DESTDIR= exec_prefix=/usr datadir=/usr/share runstatedir=/run \
		lacme_www_user=_lacme-www lacme_www_group=nogroup \
		lacme_client_user=_lacme-client lacme_client_group=nogroup

%:
	dh $@

=== debian/watch ===
version=4
opts="mode=git,pgpmode=gittag" \
https://git.guilhem.org/lacme/ refs/tags/v([\d\.]+)
